#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Sat May  9 23:55:30 2020

@author: mario
"""
import dominating_set
import k_transitive_closure
import networkx as nx

def solve(G,k):
    G_prime = k_transitive_closure.make_closure(G,k)
    dominating_set.solve(G_prime)
    
def model(G, k, name):
    G_prime = k_transitive_closure.make_closure(G,k)
    return dominating_set.model(G_prime, name)